// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// public $Header: /LocalDeveloper/Source/CVS/OmniGroup/OIF/OIAnimation.h,v 1.6 1997/12/19 09:50:44 bungi Exp $

#import <OWF/OWAbstractContent.h>

@class NSLock;
@class NSMutableArray;
@class OIAnimationInstance;
@class OIAnimationFrame;
@class OIImage;

#define OIAnimationInfiniteLoopCount ((unsigned int) -1)

@interface OIAnimation : OWAbstractContent
{
    NSMutableArray *frames;
    unsigned int    loopCount;
    NSMutableArray *waitingInstances;
    BOOL            haveAllFrames;
    NSLock         *lock;
}

- initWithLoopCount:(unsigned int)loops;

- (void)addFrame:(OIAnimationFrame *)frame;
- (void)endFrames;

- (OIImage *)animationInstance; // each call returns new instance 

- (unsigned int)loopCount;
- (void)animationInstance:(OIAnimationInstance *)instance wantsFrame:(unsigned int)frameNumber;

@end
