// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// public $Header: /LocalDeveloper/Source/CVS/OmniGroup/OIF/OIImage.h,v 1.6 1997/12/23 20:15:36 bungi Exp $

#import <OWF/OWAbstractContent.h>

@class NSData, NSMutableArray;
@class NSImage;

#import <OWF/OWContentProtocol.h>
#import "OIImageObserverProtocol.h"
#import "OIImageSourceDataProtocol.h"

@interface OIImage : OWAbstractContent
{
    BOOL			haveSize;
    unsigned int                imageWidth, imageHeight;
    NSImage                    *nsImage;

    NSMutableArray             *observerValues;
    id <OIImageSourceData>	sourceData;
}

+ (OWContentType *)contentType;

- (BOOL)hasSize;
- (unsigned int)width;
- (unsigned int)height;
- (NSImage *)image;

- (void)setImageWidth:(unsigned int)aWidth height:(unsigned int)aHeight;
- (void)updateImage:(NSImage *)anImage;
- (void)abortImage;

- (void)addObserver:(id <OIImageObserver>)anObserver;
/*.doc.
Subscribed anObserver to receive messages described in the OIImageObserver protocol.  The new observer is not retained.  The new observer is responsible for unsubscribing itself before it gets deallocated.
*/

- (void)removeObserver:(id <OIImageObserver>)anObserver;
/*.doc.
Unsubscribes anObserver such that it will not receive the messages described in the OIImageObserver protocol.
*/

- (void)setSourceData:(id <OIImageSourceData>)imageSourceData;

@end
