// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Processors.subproj/Protocols.subproj/OWNNTPSession.h,v 1.5 1998/01/26 05:50:03 kc Exp $

#import <OmniFoundation/OFObject.h>

@class ONHost, ONSocket, ONSocketStream;
@class OWContentType, OWPipeline, OWProcessor;

@interface OWNNTPSession : OFObject
{
    ONSocketStream *controlSocketStream;
    NSString *newsLocation;
    OWPipeline *nonretainedPipeline;
    OWProcessor *nonretainedProcessor;
    NSString *lastReply;
    unsigned int lastReplyIntValue;
    BOOL abortFetch;
}

+ (ONHost *)nntpServerHost;

+ (OWContentType *)newsgroupArticleType;
+ (OWContentType *)newsgroupHeaderListType;

+ (void)readDefaults;
+ (OWNNTPSession *)nntpSession;
+ (OWNNTPSession *)nntpSessionForNewsLocation:(NSString *)location;

- (void)setNewsLocation:(NSString *)location;
- (void)fetchForProcessor:(OWProcessor *)aProcessor inPipeline:(OWPipeline *)aPipeline;
- (void)abortFetch;

@end
