// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniAppKit/Preferences.subproj/OAPreferenceController.h,v 1.2 1998/01/12 06:52:29 kc Exp $

#import <OmniFoundation/OFObject.h>

@class NSBox, NSMatrix, NSMutableArray, NSMutableDictionary, NSWindow;
@class OAPreferenceClient, OAPreferenceController;

#import <AppKit/NSNibDeclarations.h> // For IBOutlet

@interface OAPreferenceController : OFObject
{
    IBOutlet NSWindow *window;
    IBOutlet NSMatrix *buttonMatrix;
    IBOutlet NSBox    *box;

    OAPreferenceClient  *currentClient;
    NSMutableArray      *clientRecordsArray;
    NSMutableDictionary *clientClassNamesToClientRecordDictionary;
    NSMutableDictionary *clientClassNamesToInstancesDictionary;
}

+ (OAPreferenceController *)sharedPreferenceControllerNamed:(NSString *)controllerName;
+ (OAPreferenceController *)sharedPreferenceController;

- (OAPreferenceClient *) clientNamed: (NSString *) clientName;

    // Actions

- (void)showPreferencesPanel:(id)sender;
- (void)close;
- (void)selectPreference:(id)sender;

@end
