// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// public $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/OFObject.h,v 1.12 1998/02/14 02:41:04 kc Exp $ */

#ifndef OFObjectHeader
#define OFObjectHeader

#import <OmniBase/OBObject.h>

@interface OFObject : OBObject
{
    unsigned int retainCount;
}

@end

typedef unsigned char byte;

#ifndef YELLOW_BOX

// These are defined in NSObject but weren't made fully public in OPENSTEP.  (They have been made public in the Rhapsody Developer Release.)  Objects that do not call the superclass version of -allocWithZone:, -dealloc, -copyWithZone:, -autorelaese, -retain, or -release should call NSRecordAllocationEvent.

// See NSDebug.h for more details.

typedef enum _NSAllocationEvent {
    NSObjectAllocatedEvent = 0,
    NSObjectDeallocatedEvent,
    NSObjectCopiedEvent,
    NSObjectAutoreleasedEvent,
    NSObjectExtraRefIncrementedEvent,
    NSObjectExtraRefDecrementedEvent,
    NSObjectInternalRefIncrementedEvent,
    NSObjectInternalRefDecrementedEvent,
    NSObjectPoolDeallocStartedEvent,
    NSObjectPoolDeallocFinishedEvent,

    NSZoneMallocEvent = 16,
    NSZoneCallocEvent,
    NSZoneReallocEvent,
    NSZoneFreeEvent,
    NSVMAllocateEvent,
    NSVMDeallocateEvent,
    NSVMCopyEvent,
    NSZoneCreatedEvent,
    NSZoneRecycledEvent
} NSAllocationEvent;

FOUNDATION_EXPORT void NSRecordAllocationEvent(NSAllocationEvent event, id object, const void *data1, const void *data2, const void *data3);

#endif

#endif // OFObjectHeader
