// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// public $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/Scheduling.subproj/OFScheduler.h,v 1.3 1997/12/28 15:15:41 wjs Exp $

#import "OFObject.h"

@class NSDate, NSRecursiveLock, NSMutableArray, NSTimer;
@class OFScheduledEvent;

#import <Foundation/NSDate.h> // For NSTimeInterval

@interface OFScheduler : OFObject
{
    NSTimer                    *alarmTimer;

    NSMutableArray             *scheduleQueue;
    NSRecursiveLock            *scheduleLock;
}

+ (OFScheduler *)mainScheduler;

- (OFScheduledEvent *)scheduleSelector:(SEL)selector onObject:(id)anObject withObject:(id)anArgument atDate:(NSDate *)date;
- (OFScheduledEvent *)scheduleSelector:(SEL)selector onObject:(id)anObject withObject:(id)anArgument afterTime:(NSTimeInterval)time;

- (void)abortEvent:(OFScheduledEvent *)anEvent;
- (void)abortSchedule;

- (OFScheduler *)subScheduler;

@end
