// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// public $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/OFUserDefaults.h,v 1.3 1997/12/04 04:32:35 kc Exp $

#import "OFObject.h"

@class NSArray, NSData;

@interface OFUserDefaults : OFObject
{
    NSString *ownerName;
    NSMutableDictionary *defaultsDictionary;
    NSMutableDictionary *globalDefaultsDictionary;
    NSMutableDictionary *registrationDictionary;
    NSMutableDictionary *overrideNetInfoDictionary;
    NSMutableDictionary *advisoryNetInfoDictionary;
    unsigned int changeCount;
}

+ (OFUserDefaults *)sharedUserDefaults;

- (void)setOwnerName:(NSString *)ownerName;
- (NSString *)ownerName;

- (void)readDefaultsDatabase;

- (NSDictionary *)defaultsDictionary;
- (NSDictionary *)registrationDictionary;
- (NSDictionary *)overrideNetInfoDictionary;
- (NSDictionary *)advisoryNetInfoDictionary;
- (unsigned int)changeCount;

- (id)objectForKey:(NSString *)defaultName;

- (NSArray *)arrayForKey:(NSString *)defaultName;
- (BOOL)boolForKey:(NSString *)defaultName;
- (NSData *)dataForKey:(NSString *)defaultName;
- (NSDictionary *)dictionaryForKey:(NSString *)defaultName;
- (float)floatForKey:(NSString *)defaultName;
- (int)integerForKey:(NSString *)defaultName;
- (NSArray *)stringArrayForKey:(NSString *)defaultName;
- (NSString *)stringForKey:(NSString *)defaultName;


- (void)removeObjectForKey:(NSString *)defaultName;

- (void)setObject:(id)value forKey:(NSString *)defaultName;

- (void)setBool:(BOOL)value forKey:(NSString *)defaultName;
- (void)setFloat:(float)value forKey:(NSString *)defaultName;
- (void)setInteger:(int)value forKey:(NSString *)defaultName;


- (void)registerDefaults:(NSDictionary *)dictionary;	

@end

